CreateStatus proc hParent:DWORD
	
    LOCAL sbParts[4] :DWORD

    invoke CreateStatusWindow,WS_CHILD or WS_VISIBLE or \
                              SBS_SIZEGRIP,NULL, hParent, 200
    mov hStatus, eax
      
  ; -------------------------------------
  ; sbParts is a DWORD array of 4 members
  ; -------------------------------------
    mov [sbParts +  0], 120
    mov [sbParts +  4], 240
    mov [sbParts +  8], 360
    mov [sbParts + 12], -1

    invoke SendMessage,hStatus,SB_SETPARTS, 4,ADDR sbParts

    ret

CreateStatus endp

lnString proc pStr:DWORD
	xor ecx,ecx
	mov eax,pStr
	lnLoop:
		mov dl,byte ptr [eax+ecx]
		inc ecx
		cmp dl,byte ptr 0
		jne lnLoop
	dec ecx	
	mov eax,ecx    
	ret

lnString endp  
strCopy proc pDest:DWORD,pSource:DWORD
	mov ecx, pSource	; put address into the source index
    mov edx, pDest		; put address into the destination index
    copyLoop:
    	mov al,byte ptr [ecx]    ; copy byte at address in esi to al
    	inc ecx			
    	mov byte ptr [edx],al    ; copy byte in al to address in edi
    	inc edx			
    	cmp al,0		
    	jne copyLoop	
	ret

strCopy endp
EmptyBuffer proc pBuffer:DWORD,nSize:DWORD
	mov edx,pBuffer
	xor ecx,ecx
	emptyLoop:
		mov BYTE PTR [edx],BYTE PTR 0
		inc ecx
		inc edx
		cmp ecx,nSize
		jne emptyLoop
		endLoop:
	ret
EmptyBuffer endp
SetToClipboard proc hWin:DWORD,hGrid:DWORD
	LOCAL hMem  :DWORD
	LOCAL nSize :DWORD
	
	invoke SendMessage,hGrid,GM_GETCLIPSIZE,0,0
	mov nSize,eax
	invoke OpenClipboard,hWin
	invoke EmptyClipboard
	invoke GlobalAlloc,GHND,nSize
	mov hMem,eax
	invoke GlobalLock,eax
	;eax contents the pointer of buffer
	invoke SendMessage,hGrid,GM_GETCLIPTEXT,eax,0
	invoke GlobalUnlock,hMem
	invoke SetClipboardData,CF_TEXT,hMem
	invoke CloseClipboard
	
	ret
SetToClipboard endp
GetFromClipboard proc hWin:DWORD,hGrid:DWORD
	LOCAL hMem:DWORD
	
	invoke OpenClipboard,hWin
	invoke GetClipboardData,CF_TEXT
	mov hMem,eax
	invoke GlobalLock,eax
	invoke SendMessage,hGrid,GM_SETCLIPTEXT,eax,0
	invoke GlobalUnlock,hMem
	invoke CloseClipboard
	
	ret
GetFromClipboard endp
SelectColor proc hWin:DWORD,crColor:DWORD
	LOCAL chColor	:CHOOSECOLOR
	LOCAL crv[16]	:DWORD

    lea edi, crv[0]
    mov ecx, 16
    mov eax, 0FFFFFFh
    rep stosd
	mov chColor.lStructSize,sizeof CHOOSECOLOR
	push hWin
	pop chColor.hwndOwner
	push hInstance
	pop chColor.hInstance
	push crColor
	pop chColor.rgbResult
	mov chColor.Flags,CC_FULLOPEN or CC_RGBINIT
	lea eax, crv 
	mov chColor.lpCustColors,eax
	mov chColor.lCustData,NULL
	mov chColor.lpfnHook,NULL
	mov chColor.lpTemplateName,NULL
	invoke ChooseColor,addr chColor
	mov eax,chColor.rgbResult
	
	ret
SelectColor endp
CountCols proc hWin:DWORD,numCols:DWORD
	LOCAL szText[3]	:BYTE
	LOCAL curCol	:DWORD
	push esi
	push edi
	push ebx
	xor ebx,ebx
	xor esi,esi
	lea edi,szText
	mov BYTE PTR [edi],0
	mov BYTE PTR [edi+1],0
	mov BYTE PTR [edi+2],0
	mov bl,1
	mov curCol,1
	Loop1:
		add bl,64
		mov BYTE PTR [edi],bl
		mov edx,curCol
		MAKEDWORD dx,0
		invoke SendMessage,hWin,GM_SETCELLTEXT,eax,edi
		sub bl,64
		inc bl
		inc curCol
		mov edx,curCol
		cmp edx,numCols
		je Finish
		cmp bl,27
		jne Loop1
	Label1:
		inc esi
		mov bl,1
		Loop2:
			mov eax,esi
			add al,64
			mov BYTE PTR [edi],al
			add bl,64
			mov BYTE PTR [edi+1],bl
			mov edx,curCol
			MAKEDWORD dx,0
			invoke SendMessage,hWin,GM_SETCELLTEXT,eax,edi
			sub bl,64
			inc bl
			inc curCol
			mov edx,curCol
			cmp edx,numCols
			je Finish
			cmp bl,27
			jne Loop2
		jmp Label1
		Finish:	
	pop ebx
	pop edi
	pop esi
	ret
CountCols endp
CountRows proc hWin:DWORD,numRows:DWORD
	LOCAL szText[6]	:BYTE
	push edi
	push esi
	lea esi,szText
	mov edi,DWORD PTR 1
	RowsLoop:
		invoke dw2a,edi,esi
		MAKEDWORD 0,di
		invoke SendMessage,hWin,GM_SETCELLTEXT,eax,esi
		inc edi
		cmp edi,numRows
		jne RowsLoop
	pop esi	
	pop edi	   
	ret
CountRows endp


